#pragma once

#include <stddef.h>
#include <stdbool.h>

typedef struct {
	void		*next;
	void		*current;
	void		*prev;
    size_t		size;
    bool		is_used;
	long		block_id;
	void		*data_start;
} chunk_t;

enum {
	CHUNK_NEXT_POS,
	CHUNK_CURRENT_POS,
	CHUNK_PREV_POS,
	CHUNK_SIZE_POS,
	CHUNK_IS_USED_POS,
	CHUNK_BLOCK_ID_POS,
	CHUNK_DATA_START_POS,
	BOZO
};

#define HEADER_SIZE BOZO * sizeof(void*)

enum {
	TINY,
	SMALL,
	LARGE
};

void	chunk_read(void * const *block, chunk_t *chunk);
void	chunk_write(const chunk_t *chunk);
void	chunk_init(chunk_t *chunk, size_t size, long block_id, void *prev, void *current, void *next, bool is_used);
size_t	get_physical_size(const chunk_t *chunk);
void 	chunk_print(const chunk_t *chunk);