#include "chunk.h"
#include "malloc.h"
#include "block.h"

void *raw_get_last_chunk(void **root)
{
    void    **current = root;

    if (current == NULL)
        return NULL;

    while (current[CHUNK_NEXT_POS] != NULL)
        current = current[CHUNK_NEXT_POS];

    return current;
}

void    *raw_get_chunk(void **root, void *data_start)
{
    void**current = root;

    while (current != NULL)
    {
        if (current[CHUNK_DATA_START_POS] == data_start)
            return current;
        
        current = current[CHUNK_NEXT_POS];
    }

    return NULL;
}

int get_unused_chunk_raw(void *root, size_t size, chunk_t *result)
{
    void** current = root;

    while (current != NULL)
    {
        if ((bool) current[CHUNK_IS_USED_POS] == false)
        {
            if ((size_t) current[CHUNK_SIZE_POS] >= size)
            {
                chunk_read(current, result);
                return 0;
            }
        }
        current = current[CHUNK_NEXT_POS];
    }
    return 1;
}

int is_alone_on_block(const chunk_t *chunk)
{
    if (chunk->prev)
        if (((long) ((void **) chunk->prev)[CHUNK_BLOCK_ID_POS]) == chunk->block_id)
            return 0;
    if (chunk->next)
        if (((long) ((void **) chunk->next)[CHUNK_BLOCK_ID_POS]) == chunk->block_id)
            return 0;
    return 1;
}